// Test.java
import java.io.*;
import java.util.*;

public class Test {
    public static void main(String[] args) throws Exception {
        ExpressionParser p = new ExpressionParser();
        ExpressionParser.Node expr = p.parseRoot(new File(args[0]), null);
        double value = evaluate(expr);
        System.out.println(value);
    }
    public static double evaluate(ExpressionParser.Node node) {
        if (node instanceof ExpressionParser.Token) {
            ExpressionParser.Token token = (ExpressionParser.Token) node;
            String image = token.getImage();
            return Double.parseDouble(image);
        } else if (node instanceof ExpressionParser.Addition) {
            ExpressionParser.Addition n = (ExpressionParser.Addition) node;
            double v1 = evaluate(n.operand1());
            double v2 = evaluate(n.operand2());
            return v1 + v2;
        } else if (node instanceof ExpressionParser.Subtraction) {
            ExpressionParser.Subtraction n = (ExpressionParser.Subtraction) node;
            double v1 = evaluate(n.operand1());
            double v2 = evaluate(n.operand2());
            return v1 - v2;
        } else if (node instanceof ExpressionParser.Multiplication) {
            ExpressionParser.Multiplication n = (ExpressionParser.Multiplication) node;
            double v1 = evaluate(n.operand1());
            double v2 = evaluate(n.operand2());
            return v1 * v2;
        } else if (node instanceof ExpressionParser.Division) {
            ExpressionParser.Division n = (ExpressionParser.Division) node;
            double v1 = evaluate(n.operand1());
            double v2 = evaluate(n.operand2());
            return v1 / v2;
        } else if (node instanceof ExpressionParser.Paren) {
            ExpressionParser.Paren n = (ExpressionParser.Paren) node;
            double v = evaluate(n.expression());
            return v;
        } else if (node instanceof ExpressionParser.Root) {
            ExpressionParser.Root n = (ExpressionParser.Root) node;
            double v = evaluate(n.expression());
            return v;
        } else {
            throw new IllegalArgumentException("" + node);
        }
    }
}
